#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#define MAXFICH 10

#define erreur(e) { fprintf(stderr,"Error: " e "\n"); exit(1); }

char *compiler(char *,int *);

long *bufn;
char *bufc;
int bufl;
long *stk;

int nbf=0;
FILE *fic[MAXFICH];
long orig[MAXFICH];
long val[MAXFICH];
int nbo=1,pcf=0,oro=0;
long msk;

void optimiser(char *e,int l)
{
  int i,j,k;

  for(i=j=0;i<l;i++){
    if(e[i]==0){
      j++;
      i+=4;
    }
  }
  bufn=malloc(l);
  bufc=(char *)(bufn+j);
  for(i=j=k=0;i<l;i++){
    bufc[j++]=e[i];
    if(e[i]==0){
      bufn[k++]=*(long *)(e+i+1);
      i+=4;
    }
  }
  bufl=j;
  free(e);
}

void argument(char *a)
{
  if(a[0]=='-'){
    switch(a[1]){
      case '1': nbo=1; break;
      case '2': nbo=2; break;
      case '4': nbo=4; break;
      case '%':
	pcf=atoi(a+2);
	if((pcf<0)||(pcf>=100)) erreur("bad number");
	break;
      case 'g': oro=0; break;
      case 'd': oro=1; break;
    }
  }else if(a[0]=='+'){
    if(nbf==0) erreur("origin without file");
    orig[nbf-1]=atol(a+1);
    if(orig[nbf-1]<0) erreur("negative origin");
  }else{
    if(nbf==MAXFICH) erreur("too many files");
    fic[nbf]=fopen(a,"rb");
    if(fic[nbf]==NULL) erreur("file not found");
    orig[nbf]=0L;
    nbf++;
  }
}

long evaluer(void)
{
  int i,j=0;
  long a,b;
  char c;

  for(i=0;i<bufl;i++){
    switch(c=bufc[i]){
      case 0: *(stk++)=bufn[j++]; break;
      case 1: b=*(--stk); a=*(--stk); *(stk++)=a+b; break;
      case 2: b=*(--stk); a=*(--stk); *(stk++)=a-b; break;
      case 3: b=*(--stk); a=*(--stk); *(stk++)=a*b; break;
      case 4: b=*(--stk); a=*(--stk); *(stk++)=a/b; break;
      case 5: b=*(--stk); a=*(--stk); *(stk++)=a%b; break;
      case 6: b=*(--stk); a=*(--stk); *(stk++)=a&b; break;
      case 7: b=*(--stk); a=*(--stk); *(stk++)=a|b; break;
      case 8: b=*(--stk); a=*(--stk); *(stk++)=a^b; break;
      case 9: b=*(--stk); a=*(--stk); *(stk++)=(a==b); break;
      case 10: b=*(--stk); a=*(--stk); *(stk++)=(a!=b); break;
      case 11: b=*(--stk); a=*(--stk); *(stk++)=(a>b); break;
      case 12: b=*(--stk); a=*(--stk); *(stk++)=(a>=b); break;
      case 13: b=*(--stk); a=*(--stk); *(stk++)=(a<b); break;
      case 14: b=*(--stk); a=*(--stk); *(stk++)=(a<=b); break;
      case 15: a=*(--stk); *(stk++)=-a; break;
      case 16: a=*(--stk); *(stk++)=~a; break;
      default: *(stk++)=((c<0)&&(c>=-MAXFICH))?val[-c-1]:0; break;
    }
  }
  return(*(--stk));
}

int main(int argc,char **argv)
{
  int l,pa,ono;
  char *e;
  long lof=0x7FFFFFFFL,i,ns;
  unsigned char c;

  if(argc<2){
    printf("Usage: filescan expression [options] fichier_a [fichier_b...]\n");
    exit(0);
  }
  e=compiler(argv[1],&l);
  optimiser(e,l);
  stk=malloc(800);
  for(l=2;l<argc;l++)
    argument(argv[l]);
  if(nbf<1)
    erreur("at least one file needed");
  for(l=0;l<nbf;l++){
    fseek(fic[l],0L,SEEK_END);
    i=ftell(fic[l])-orig[l];
    fseek(fic[l],orig[l],SEEK_SET);
    if(i<lof) lof=i;
    val[l]=0;
  }
  ono=nbo;
  lof-=nbo-1;
  msk=(nbo==1?255L:(nbo==2?65535L:-1L));
  nbo<<=3; nbo-=8;
  pa=pcf;
  ns=pcf==0?-1:(pa*(lof-1))/100L;
  for(i=0;i<lof;i++){
    for(l=0;l<nbf;l++){
      c=fgetc(fic[l]);
      if(oro==0) val[l]=((((unsigned long)c)<<nbo)|(val[l]>>8))&msk;
      else val[l]=((val[l]<<8)|((unsigned long)c))&msk;
    }
    if(evaluer()){
      printf("%9lu (%8lX)  ",i-ono,i-ono);
      for(l=0;l<nbf;l++)
	printf(" %c=%11ld ",'a'+l,val[l]);
      printf("\n");
    }
    while(i==ns){
      printf("(%d%%)\n",pa);
      pa+=pcf;
      ns=(pa*(lof-1))/100L;
    }
  }
  return(0);
}
