.TH FILESCAN 1 LOCAL
.SH NAME
filescan \- compare files byte by byte

.SH SYNOPSIS
.B filescan
formula [options...] file_a [+origin] [file_b [+origin]...]

.SH DESCRIPTION
.I Filescan
compares two or more files byte by byte regarding a given expression.
The expression depends on variables a, b... which are the values of the
currents bytes of files a, b...

The expression is defined by the syntax:

Expr ::= Number
.br
       | Letter
.br
       | 
.I (
Expr
.I )
.br
       | 
.I -
Expr
.br
       |
.I !
Expr
.br
       | Expr
.I op
Expr

Where
.I op
is one of (in order of priority):

.I |
.br
.I &
.br
.I ^
.br
.I = != < > <= >=
.br
.I + -
.br
.I * / %

Each operator has the same meaning than in C language, except
.I =
which replaces
.I ==
(equality test).

The expression if evaluated for each
.I i
possible with a = file_a[i + origin_a], b = file_b[i + origin_b] ...

Each time the value is non-zero, a line is printed with i, a, b...

.SH OPTIONS
.TP
.B -1 -2 -4
The values are read respectively as bytes, words and double
words. The default is bytes.
They are converted into double words for the
evaluation. Everything is made with unsigned numbers. If the
.B -4
option is given, every byte will belongs to 4 values.

.TP
.B -%number
Prints a progression message everytime
.I number
percent of the total work is done.

.TP
.B -g
When used with the
.B -2
or
.B -4
option, tells that the numbers are read in order LSB-MSB. This is the default.

.TP
.B -g
When used with the
.B -2
or
.B -4
option, tells that the numbers are read in order MSB-LSB.

.SH EXAMPLES
.B Filescan
was first designed as a tool to crack saved games. So these few
examples will use the vocabulary of the games:

filescan 'a=20000 & b=19580' -2 city.sav city2.sav +1

Search coresponding words in city.sav and city2.sav where the first
one is 2000 and the second one 19580. As the name city2 is one char
longer than city, and the file is (maybe) one byte bigger, I assume
that everything in city2 is shifted of 1 byte, so '+1'.

filescan '(a-b=b-c)&(c-d=2*(b-c))' save1 save2 save3 save4

I've lost as many energy between save1 and save2 and between save2 and 
save3, but two times more between save3 and save4. Unfortunatly, I
don't know the exact value. Maybe 5 or 10, I'll see the credible
values on the search results.

Not that you should quote the formula to prevent the shell from doing
a filename expansion on it.

.SH AUTHOR
.B Nicolas GEORGE
<nicolas.george@ens.fr>
.br
Student at the Ecole Normale Superieure,
.br
Departement de Mathematiques et d'Informatique
