%{
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>

typedef union {
  long lg;
  struct {
    short l;
    char *e;
  } er;
} YYSTYPE;

char *op_binaire(char *e1,short l1,char *e2,short l2,char o)
{
  char *r,*s,*t;
  int i;

  r=s=malloc(l1+l2+1);
  t=e1; for(i=0;i<l1;i++) *(r++)=*(t++);
  t=e2; for(i=0;i<l2;i++) *(r++)=*(t++);
  *r=o;
  free(e1); free(e2);
  return(s);
}

void yyerror(char *s)
{
  fprintf(stderr,"Error in expression: %s\n",s);
  exit(0);
} 
%}

%token <lg> Nbr
%token <lg> Var
%token ParG ParD
%token Plus Moins Fois Sur Mod
%token Et Ou Oux Non
%token Inf Sup InfE SupE Egal Diff

%left Ou
%left Et
%left Oux
%nonassoc Non
%left Inf Sup InfE SupE Egal Diff
%left Plus Moins
%left Fois Sur Mod
%nonassoc UMoins

%start Expression0
%type <er> Expression0
%type <er> Expr

%%
Expression0:
  Expr  { $$=$1; }
;
Expr:
  ParG Expr  ParD          { $$=$2; }
| Expr Plus  Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,1); }
| Expr Moins Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,2); }
| Expr Fois  Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,3); }
| Expr Sur   Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,4); }
| Expr Mod   Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,5); }
| Expr Et    Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,6); }
| Expr Ou    Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,7); }
| Expr Oux   Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,8); }
| Expr Egal  Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,9); }
| Expr Diff  Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,10); }
| Expr Sup   Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,11); }
| Expr SupE  Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,12); }
| Expr Inf   Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,13); }
| Expr InfE  Expr          { $$.l=$1.l+$3.l+1; $$.e=op_binaire($1.e,$1.l,$3.e,$3.l,14); }
| Moins Expr %prec UMoins  { $$.e=realloc($2.e,$$.l=$2.l+1); $$.e[$2.l]=15; }
| Non Expr                 { $$.e=realloc($2.e,$$.l=$2.l+1); $$.e[$2.l]=16; }
| Nbr                      { char *r; r=malloc(5); $$.e=r; *(r++)=0; *(long *)r=$1; $$.l=5; }
| Var                      { $$.e=malloc(1); *$$.e=-1-$1; $$.l=1; }
%%

char *expr;

int yylex(void)
{
  char c;
  long r;

  while((*expr==' ')||(*expr=='\t')) expr++;
  c=*(expr++);
  if(c==0) return(EOF);
  if(c=='(') return(ParG);
  if(c==')') return(ParD);
  if(c=='+') return(Plus);
  if(c=='-') return(Moins);
  if(c=='*') return(Fois);
  if(c=='/') return(Sur);
  if(c=='%') return(Mod);
  if(c=='&') return(Et);
  if(c=='|') return(Ou);
  if(c=='^') return(Oux);
  if(c=='=') return(Egal);
  if(c=='<'){
    if(*expr=='='){ expr++; return(InfE); }
    return(Inf);
  }
  if(c=='>'){
    if(*expr=='='){ expr++; return(SupE); }
    return(Sup);
  }
  if(c=='!'){
    if(*expr=='='){ expr++; return(Diff); }
    return(Non);
  } 
  if((c>='a')&&(c<='z')){
    yylval.lg=(c-'a');
    return(Var);
  }
  if((c>='0')&&(c<='9')){
    r=0;
    for(--expr;(c>='0')&&(c<='9');c=*(++expr))
      r=10*r+(long)(c-'0');
    yylval.lg=r;
    return(Nbr);
  }
  printf("%d\n",c);
  yyerror("unknown char");
  return(0);
}

char *compiler(char *e,int *l)
{
  expr=e;
  if(yyparse()) yyerror("unknown error");
  *l=yyval.er.l;
  return(yyval.er.e);
}
